#include <stdio.h>

// extract Max Payne sounds from SOUND.EMM according to SOUND.DIR
// for little-endian machines
// by hcs (here.is/halleyscomet)

int main(void) {
    FILE * dir, * emm, * out;
    int c=0,i,lastvag=0;
    char buf[0x10],filename[20];
    unsigned long start,end,read;

    dir = fopen("SOUND.DIR","rb");
    if (dir <= 0) return 1;

    emm = fopen("SOUND.EMM","rb");
    if (emm <= 0) return 1;

    if (fread(buf,1,16,dir)!=16) return 1;
    end = ((unsigned long*)buf)[3];
    while (!lastvag && (read=fread(buf,1,16,dir))) {
        start = end;
        if (read != 16) {
            // last VAG
            fseek(emm,0,SEEK_END);
            end = ftell(emm);
            lastvag=1;
        } else {
            end = ((unsigned long*)buf)[3];
        }
        if (fseek(emm,start,SEEK_SET)) return 1;

        sprintf(filename,"SOUND%04d.VAG",c);
        printf("extracting %s from 0x%08x to 0x%08x (size %08x)...",filename,start,end,end-start);

        out = fopen(filename,"wb");
        if (out <= 0) return 1;

        for (i=0; i < (end-start)/16; i++) {
            if (fread(buf,1,16,emm)!=16) return 1;
            if (fwrite(buf,1,16,out)!=16) return 1;
        }

        fclose(out);

        printf("done\n");

        c++;
    }

    return 0;
}
